﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections.ObjectModel;

namespace XamComboEditorApp
{
    public class MainWindowViewModel : BindableBase
    {       
        public MainWindowViewModel()
        {
            this.DataCountries.Add(new Country
            {
                Name = "Country 1",
                Code = 1,
                States = new List<State>
                {
                    new State { Name = "State 1 1", Code = 1 },
                    new State { Name = "State 1 2", Code = 2 },
                    new State { Name = "State 1 3", Code = 3 }
                }
            });

            this.DataCountries.Add(new Country
            {
                Name = "Country 2",
                Code = 2,
                States = new List<State>
                {
                    new State { Name = "State 2 1", Code = 4 },
                    new State { Name = "State 2 2", Code = 5 }                    
                }
            });
        }

        ObservableCollection<Country> dataCountries = new ObservableCollection<Country>();
        public ObservableCollection<Country> DataCountries
        {
            get
            {
                return this.dataCountries;
            }

            set
            {
                if (this.dataCountries != value)
                {
                    this.dataCountries = value;
                    this.OnPropertyChanged("DataCountries");
                }
            }
        }

        ObservableCollection<State> dataStates = new ObservableCollection<State>();
        public ObservableCollection<State> DataStates
        {
            get
            {
                return this.dataStates;
            }

            set
            {
                if (this.dataStates != value)
                {
                    this.dataStates = value;
                    this.OnPropertyChanged("DataStates");
                }
            }
        }

        private Country selectedCountry;
        public Country SelectedCountry
        {
            get
            {
                return this.selectedCountry;
            }

            set
            {
                if (this.selectedCountry != value)
                {
                    this.selectedCountry = value;
                    OnPropertyChanged("SelectedCountry");

                    this.DataStates = new ObservableCollection<State>(this.selectedCountry.States);

                    this.SelectedState = this.DataStates[0];
                }                
            }
        }

        private State selectedState;
        public State SelectedState
        {
            get
            {
                return this.selectedState;
            }

            set
            {
                if (this.selectedState != value)
                {
                    this.selectedState = value;
                    OnPropertyChanged("SelectedState");                    
                }
            }
        }
    }
}